"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class DeliveryTask(ProtocolElement):
    """
    Defines a delivery task. A delivery task identifies an instance of the
    whole delivery     interaction cycle, whether successful or not.
    This allows traceability and identification     of failed
    deliveries
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "basePath",
        "protocolVersion",
        "rareOrCancer",
        "tieringResultId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_3_0_0 import reports as reports_3_0_0

        return {
            "org.gel.models.report.avro.DeliveryTask": reports_3_0_0.DeliveryTask,
        }

    __slots__ = [
        "basePath",
        "protocolVersion",
        "rareOrCancer",
        "tieringResultId",
    ]

    def __init__(
        self,
        basePath,
        protocolVersion,
        rareOrCancer,
        tieringResultId,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_3_0_0.DeliveryTask model.

        :param basePath:
            Base path on MDT storage where GEL should transfer files associated
            with the study
        :type basePath: str
        :param protocolVersion:
        :type protocolVersion: str
        :param rareOrCancer:
        :type rareOrCancer: str
        :param tieringResultId:
        :type tieringResultId: int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
